<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetOrdersStatusHistoryResponse StructType
 * @subpackage Structs
 */
class GetOrdersStatusHistoryResponse extends AbstractStructBase
{
    /**
     * The Succeeded
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Succeeded;
    /**
     * The GetOrdersStatusHistoryResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GetOrdersStatusHistoryResponse
     */
    public $GetOrdersStatusHistoryResult;
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * The Orders
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfOrderGroup
     */
    public $Orders;
    /**
     * Constructor method for GetOrdersStatusHistoryResponse
     * @uses GetOrdersStatusHistoryResponse::setSucceeded()
     * @uses GetOrdersStatusHistoryResponse::setGetOrdersStatusHistoryResult()
     * @uses GetOrdersStatusHistoryResponse::setError()
     * @uses GetOrdersStatusHistoryResponse::setOrders()
     * @param bool $succeeded
     * @param \StructType\GetOrdersStatusHistoryResponse $getOrdersStatusHistoryResult
     * @param string $error
     * @param \ArrayType\ArrayOfOrderGroup $orders
     */
    public function __construct($succeeded = null, \StructType\GetOrdersStatusHistoryResponse $getOrdersStatusHistoryResult = null, $error = null, \ArrayType\ArrayOfOrderGroup $orders = null)
    {
        $this
            ->setSucceeded($succeeded)
            ->setGetOrdersStatusHistoryResult($getOrdersStatusHistoryResult)
            ->setError($error)
            ->setOrders($orders);
    }
    /**
     * Get Succeeded value
     * @return bool
     */
    public function getSucceeded()
    {
        return $this->Succeeded;
    }
    /**
     * Set Succeeded value
     * @param bool $succeeded
     * @return \StructType\GetOrdersStatusHistoryResponse
     */
    public function setSucceeded($succeeded = null)
    {
        // validation for constraint: boolean
        if (!is_null($succeeded) && !is_bool($succeeded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($succeeded, true), gettype($succeeded)), __LINE__);
        }
        $this->Succeeded = $succeeded;
        return $this;
    }
    /**
     * Get GetOrdersStatusHistoryResult value
     * @return \StructType\GetOrdersStatusHistoryResponse|null
     */
    public function getGetOrdersStatusHistoryResult()
    {
        return $this->GetOrdersStatusHistoryResult;
    }
    /**
     * Set GetOrdersStatusHistoryResult value
     * @param \StructType\GetOrdersStatusHistoryResponse $getOrdersStatusHistoryResult
     * @return \StructType\GetOrdersStatusHistoryResponse
     */
    public function setGetOrdersStatusHistoryResult(\StructType\GetOrdersStatusHistoryResponse $getOrdersStatusHistoryResult = null)
    {
        $this->GetOrdersStatusHistoryResult = $getOrdersStatusHistoryResult;
        return $this;
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \StructType\GetOrdersStatusHistoryResponse
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Get Orders value
     * @return \ArrayType\ArrayOfOrderGroup|null
     */
    public function getOrders()
    {
        return $this->Orders;
    }
    /**
     * Set Orders value
     * @param \ArrayType\ArrayOfOrderGroup $orders
     * @return \StructType\GetOrdersStatusHistoryResponse
     */
    public function setOrders(\ArrayType\ArrayOfOrderGroup $orders = null)
    {
        $this->Orders = $orders;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOrdersStatusHistoryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
